#pragma once
#include "node.h"
class CRenderableNode :
	public CNode
{
public:
	CRenderableNode(void);
	~CRenderableNode(void);
	
	glm::mat4 ModelMatrix;

	void Draw(void);
	
	static const int _GLSL_MODELVIEWPROJECTION_MATRIX_POS = 0;
	static const int _GLSL_MODELVIEW_MATRIX_POS = 1;
	static const int _GLSL_NORMAL_MATRIX_POS = 2;
	static const int _GLSL_PROJECTION_MATRIX_POS = 3;
	
	static const int _GLSL_VERTEX_POSITION_POS = 0;
	static const int _GLSL_VERTEX_NORMAL_POS = 1;

protected:
	GLuint vboId;
	GLuint vaoId;
	int NumVertices;

	unsigned int VBO_STRIDE;
	unsigned int Primitive;
	CShadingProgram * ShadingProgram;
	
	void Init(void);
	virtual void PrepareGeometryBuffer(void);
	virtual void PrepareGeometryPointers(void);
	virtual void BindUniforms(void);
	virtual void Render(void);
	virtual void UpdateModelMatrix(void);

};

