#pragma once

class CSphere;

class CScene
{

public:
	CScene(void);
	~CScene(void);
	virtual void Init(void);
	virtual void Redraw(void);
	virtual void Update(void);
	void Activate(void);
	void BindLights(void);

	void AddNode(CNode * node);

	CCamera Camera;

	std::vector<CNode *> Nodes;
	std::vector<CLight *> Lights;

	double Time;

	CShadingProgram * SP_General;

public:
	static CScene * GetCurrent(void);
private:
	static CScene * Current;

};

