#pragma once

typedef struct {
   double x, y, z;
   double xn, yn, zn;
} XYZ;

typedef struct {
   XYZ p1,p2,p3;
} FACET3;

class CSphere : public CRenderableNode
{
public:
	CSphere(int iterations);
	~CSphere(void);
	FACET3 * Faces;
	int NFaces;
protected:
	int CreateUnitSphere(int iterations, FACET3 * Faces);
	XYZ MidPoint(XYZ p1, XYZ p2);
	void Normalise(XYZ * p);
	void CalculateNormal(XYZ * vertex);
	
	void PrepareGeometryBuffer(void);
	void PrepareGeometryPointers(void);
};

